// ServiceMgrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ServiceMgr.h"
#include "ServiceMgrDlg.h"
#include  <winsvc.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServiceMgrDlg dialog

CServiceMgrDlg::CServiceMgrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServiceMgrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServiceMgrDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CServiceMgrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServiceMgrDlg)
	DDX_Control(pDX, IDC_LIST_SERVICE, m_lstServices);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CServiceMgrDlg, CDialog)
	//{{AFX_MSG_MAP(CServiceMgrDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_AUTOMATIC, OnButtonAutomatic)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_MANUAL, OnButtonManual)

	ON_BN_CLICKED(IDC_BUTTON_RUN, OnButtonRun)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, OnButtonRefresh)
	ON_BN_CLICKED(IDC_BUTTON_VISIT, OnButtonVisit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServiceMgrDlg message handlers

BOOL CServiceMgrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	this->m_lstServices.InsertColumn(0,"No",LVCFMT_LEFT,25);
	this->m_lstServices.InsertColumn(1,"Service Name",LVCFMT_LEFT,100);
	this->m_lstServices.InsertColumn(2,"Display Name",LVCFMT_LEFT,140);
	this->m_lstServices.InsertColumn(3,"Status",LVCFMT_LEFT,50);
	this->m_lstServices.InsertColumn(4,"Startup Type",LVCFMT_LEFT,80);
	
	this->UpDateListCtrl();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CServiceMgrDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CServiceMgrDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CServiceMgrDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CServiceMgrDlg::OnButtonAutomatic() 
{	
	POSITION pos;
	pos=this->m_lstServices.GetFirstSelectedItemPosition();
	
		if(pos==NULL)
		{
		 MessageBox("Please Select the Service to Start");
		 return;
		}
		else
		{
			int nItem=this->m_lstServices.GetNextSelectedItem(pos);
			CString strServiceName=this->m_lstServices.GetItemText(nItem,1);
			
			SC_HANDLE ScManager,ScService;
			
			if((ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS))==NULL)
			{MessageBox("Error Opening System Manager");
				 return;
				
			}
			if((ScService=::OpenService(ScManager,strServiceName,SERVICE_ALL_ACCESS))==NULL)
			{MessageBox("Error Opening Service");
								return;
								
			}

			::ChangeServiceConfig(ScService,SERVICE_NO_CHANGE,SERVICE_AUTO_START,SERVICE_NO_CHANGE,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
			
		}
			///refreshing value
			 this->UpDateListCtrl();
			
			
			
			
}

void CServiceMgrDlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	
	POSITION pos;
	pos=this->m_lstServices.GetFirstSelectedItemPosition();
	
		if(pos==NULL)
		{
		 MessageBox("Please Select the Service to Start");
		 return;
		}
		else
		{
			int nItem=this->m_lstServices.GetNextSelectedItem(pos);
			CString strServiceName=this->m_lstServices.GetItemText(nItem,1);
			
			SC_HANDLE ScManager,ScService;
			
			if((ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS))==NULL)
			{MessageBox("Error Opening System Manager");
				 return;
				
			}
			if((ScService=::OpenService(ScManager,strServiceName,SERVICE_ALL_ACCESS))==NULL)
			{MessageBox("Error Opening Service");
								return;
								

			}
			
			::ChangeServiceConfig(ScService,SERVICE_NO_CHANGE,SERVICE_DISABLED,SERVICE_NO_CHANGE,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
			
		}
			///refreshing value
			 this->UpDateListCtrl();
	
}

void CServiceMgrDlg::OnButtonManual() 
{
	// TODO: Add your control notification handler code here
	
	POSITION pos;
	pos=this->m_lstServices.GetFirstSelectedItemPosition();
	
		if(pos==NULL)
		{
		 MessageBox("Please Select the Service to Start");
		 return;
		}
		else
		{
			int nItem=this->m_lstServices.GetNextSelectedItem(pos);
			CString strServiceName=this->m_lstServices.GetItemText(nItem,1);
			
			SC_HANDLE ScManager,ScService;
			
			if((ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS))==NULL)
			{
				 MessageBox("Error Opening System Manager");
				 return;
			}
			if((ScService=::OpenService(ScManager,strServiceName,SERVICE_ALL_ACCESS))==NULL)
			{
				MessageBox("Error Opening Service");
								return;
								
			}

			::ChangeServiceConfig(ScService,SERVICE_NO_CHANGE,SERVICE_DEMAND_START,SERVICE_NO_CHANGE,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
			
		}
			///refreshing value
			 this->UpDateListCtrl();
	
}

void CServiceMgrDlg::OnButtonRestart() 
{
	this->OnButtonStop();
	::Sleep(1000);
	this->OnButtonRun();
}	

	void CServiceMgrDlg::OnButtonRun() 
	{
		 POSITION pos;
			 
			 pos=this->m_lstServices.GetFirstSelectedItemPosition();
			 
			 if(pos==NULL)
			 {
				 
				 MessageBox("Please Select the Service to Start");
			    
				 return;
			 }
			 else
			 {
				 int nItem=this->m_lstServices.GetNextSelectedItem(pos);
				 CString strServiceName=this->m_lstServices.GetItemText(nItem,1);
				 
				 
			 				SC_HANDLE ScManager,ScService;//Declaring the Some USeful Variable
							
							if((ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS))==NULL)
							{
								
								//preparing Error Variable
							 MessageBox("Error Opening System Manager");
								return;
								
							}
							
							if((ScService=::OpenService(ScManager,strServiceName,SERVICE_ALL_ACCESS))==NULL)
							{
								//preparing Error Variable
								MessageBox("Error Opening Service");
								return;
								
							}
							
							if(::StartService(ScService,0,NULL)==0)
							{
								//preparing Error Variable
								MessageBox("Error Starting Service");
								return;
								
							}
			 }
			///refreshing value
			 this->UpDateListCtrl();
	}

	void CServiceMgrDlg::OnButtonStop() 
	{
		POSITION pos;
			SERVICE_STATUS stt;
				 
				 pos=this->m_lstServices.GetFirstSelectedItemPosition();
				 
				 if(pos==NULL)
				 {
					 
					 MessageBox("Please Select the Service to Start");
					
					 return;
				 }
				 else
				 {
					 int nItem=this->m_lstServices.GetNextSelectedItem(pos);
					 CString strServiceName=this->m_lstServices.GetItemText(nItem,1);
					 {////////////////STOP BLOCK
							SC_HANDLE ScManager,ScService;//Declaring the Some USeful Variable
							
							if((ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS))==NULL)
							{
								//preparing Error Variable
									 MessageBox("Error Opening System Manager");
								return;
								
							}
							
							if((ScService=::OpenService(ScManager,strServiceName,SERVICE_ALL_ACCESS))==NULL)
							{
								//preparing Error Variable
									 MessageBox("Error Opening Service");
								return;
							}
							
							if(::ControlService(ScService,SERVICE_CONTROL_STOP,&stt)==0)
							{
								//preparing Error Variable
								MessageBox("Error: Unable to Stop Service");
								return;
								
							}
							
				 
					 }
				 }
				 ////
				 ///ReFresh data
				 this->UpDateListCtrl();
	}

	void CServiceMgrDlg::UpDateListCtrl()
	{

		  ///
		//delete all item in listctrl
		this->m_lstServices.DeleteAllItems();

						SC_HANDLE ScManager;
						ENUM_SERVICE_STATUS EnService[512];
						DWORD   cbBufSize=512*sizeof(ENUM_SERVICE_STATUS);
						// size of status buffer
						DWORD lpServicesReturned;
						DWORD   pcbBytesNeeded;           // buffer size needed
						DWORD   lpResumeHandle=0;           // next entry
						CString str,csTemp;
						
						ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ENUMERATE_SERVICE|GENERIC_READ);
						
						if(ScManager==NULL)
						{
							MessageBox("Error Opening Service Mgr");
							return;
						}

						if(::EnumServicesStatus(ScManager,SERVICE_WIN32,SERVICE_STATE_ALL,EnService,cbBufSize,&pcbBytesNeeded,&lpServicesReturned,&lpResumeHandle )==0)
						{
							MessageBox("Error Querrying Service Mgr");
							return;
						}
						
						
						
						for(int i=0;i<int(lpServicesReturned);i++)
						{
							
							
							csTemp.Format("%d",i+1);
							this->m_lstServices.InsertItem(i,csTemp);
							this->m_lstServices.SetItemText(i,1,EnService[i].lpServiceName);	
							this->m_lstServices.SetItemText(i,2,EnService[i].lpDisplayName);
							
							
							
							switch(EnService[i].ServiceStatus.dwCurrentState)
							{
							case SERVICE_PAUSED:
								this->m_lstServices.SetItemText(i,3,"paused");          
								
								break;	// The service is paused. 

							case SERVICE_RUNNING:
								this->m_lstServices.SetItemText(i,3,"running");          
								break;// The service is running. 

							case SERVICE_STOPPED :
								this->m_lstServices.SetItemText(i,3,"stopped");          
								
								break;// The service is stopped
								
						  case SERVICE_START_PENDING :
							  this->m_lstServices.SetItemText(i,3,"starting");          
							  break;// The service is starting
							  
						  case SERVICE_STOP_PENDING :
							  this->m_lstServices.SetItemText(i,3,"stopping");          
							  break;// The service is stopped

						  default:
							  this->m_lstServices.SetItemText(i,3,"unknown");          
							  break;// The service is running.
							}
							//block for start type
							{
								SC_HANDLE ScService;					
								QUERY_SERVICE_CONFIG ServiceConfig;
								DWORD CbBufSize, pcbBytesNeeded;
								
								CbBufSize=sizeof(QUERY_SERVICE_CONFIG);
								
								CString SerState;
								
								if((ScService=::OpenService(ScManager,EnService[i].lpServiceName,SERVICE_ALL_ACCESS))==NULL)
								{
									::CloseHandle(ScManager);		
									"Problem in opening service";
									
								}
								
								::QueryServiceConfig(ScService,&ServiceConfig,CbBufSize,&pcbBytesNeeded);
								
								switch(ServiceConfig.dwStartType)
								{
								case	SERVICE_AUTO_START:this->m_lstServices.SetItemText(i,4,"Automatic"); break;
								case	SERVICE_DEMAND_START:this->m_lstServices.SetItemText(i,4,"Manual"); break;
								case	SERVICE_DISABLED :this->m_lstServices.SetItemText(i,4,"Disable"); break;
								default:SerState=this->m_lstServices.SetItemText(i,4,"Unknown"); 
								}
								
							
							
							}
						}
						
						//str+=CString(EnService[i].lpServiceName);
					
			  
	}

void CServiceMgrDlg::OnButtonDelete() 
{

	if(MessageBox("are You Sure You want to delete this service,this action cant UNDO","Service Manager",MB_YESNO)==IDNO)
	{
		return;
	}
		 POSITION pos;
			 
			 pos=this->m_lstServices.GetFirstSelectedItemPosition();
			 
			 if(pos==NULL)
			 {
				 
				 MessageBox("Please Select the Service to Start");
			    
				 return;
			 }
			 else
			 {
				 int nItem=this->m_lstServices.GetNextSelectedItem(pos);
				 CString strServiceName=this->m_lstServices.GetItemText(nItem,1);
				 
				 
			 				SC_HANDLE ScManager,ScService;//Declaring the Some USeful Variable
							
							if((ScManager=::OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS))==NULL)
							{
								
								//preparing Error Variable
							 MessageBox("Error Opening System Manager");
								return;
								
							}
							
							if((ScService=::OpenService(ScManager,strServiceName,SERVICE_ALL_ACCESS))==NULL)
							{
								//preparing Error Variable
								MessageBox("Error Opening Service");
								return;
								
							}
							
							if(::DeleteService(ScService)==0)
							{
								//preparing Error Variable
								MessageBox("Error Deleting Service");
								return;
								
							}else
							{
								MessageBox("Service Marked For Deletion\nDeleted After Computer Restart");

							}

			 }
			///refreshing value
			 this->UpDateListCtrl();
}

void CServiceMgrDlg::OnButtonRefresh() 
{
	// TODO: Add your control notification handler code here
   this->UpDateListCtrl();	
}

void CServiceMgrDlg::OnButtonVisit() 
{
ShellExecute(NULL, "open", "http://www.thisisalok.tk", NULL, NULL, SW_SHOWNORMAL);	
}
